/*****************************
* Source : pcretest.prg
* System : <unkown>           
* Author : Phil Ide           
* Created: 08/08/2002             
*                             
* Purpose:                    
* ----------------------------
* History:                    
* ----------------------------
*    08/08/2002 15:35 PPI - Created                
*****************************/

#include "xbpcre.ch"

function main()
   local nStart
   local nEnd
   local oReg := RegExp():new('^.*\bp[e].*l\b',PCRE_MULTILINE+PCRE_CASELESS)
   local nRet
   local aRet := {}
   local i
   local c := memoread('pcre.txt')
   local x
   local nOffset := 0

   oReg:study()
   cls
   ? 'Test #1: Locate all occurrences of the word "Perl", case insensitive.'
   ? 'Expression: '+'^.*\bp[e].*l\b'
   ? '(note: expression is more complicated than it needs to be.'
   nStart := Seconds()
   while (nRet := oReg:exec(c,nOffset)) > 0
      for i := 1 to nRet
         aadd( aRet, oReg:result(i) )
      next
      nOffset := oReg:result(1)[1]+oReg:result(1)[2]
   enddo
   nEnd := Seconds()
   ? 'Results: '+LTrim(Str(Len(aRet)))+' in '+LTrim(Str(nEnd-nStart))+' seconds'
   ? 'Press any key...(print results)'
   inkey(0)
   ?
   for i := 1 to len(aRet)
      ? substr(c,aRet[i][1],aRet[i][2])
   next


   ? 'Press any key...'
   inkey(0)
   cls
   ? 'Test #2: Count lines in file, extract offsets and length for each line'
   ? '         Print lines 1-10 and 93.'
   ? 'Expression: '+'^(.*)\x0a'
   ? 'Press any key...'
   inkey(0)
   oReg := RegExp():new('^(.*)\x0a',PCRE_MULTILINE)
   nStart := Seconds()
   oReg:study()
   ? 'Study time: '+LTrim(Str(Seconds()-nStart))
   ? 'Press any key...'
   inkey(0)
   ? '...working...'
   ?
   nOffset := 0
   aRet := {}
   nStart := Seconds()
   while (nRet := oReg:exec(c,nOffset)) > 0
      for i := 2 to nRet
         aadd( aRet, oReg:result(i) )
      next
      nOffset := oReg:result(2)[1]+oReg:result(2)[2]
   enddo
   nEnd := Seconds()
   ? 'Results: '+LTrim(Str(Len(aRet)))+' in '+LTrim(Str(nEnd-nStart))+' seconds'
   for i := 1 to 10
      ? StrZero(i,2)+':'+substr(c,aRet[i][1],aRet[i][2]) // print line 93
   next
   ? '93:'+substr(c,aRet[93][1],aRet[93][2]) // print line 93

   ? 'Press any key...'
   inkey(0)
   cls
   ? 'Test #3: Find copyright string (last line in file)'
   ? 'Expression: '+'^(.*copyright.*(\d{4})-(\d{4})*.*U.*)\x0a'
   ? 'Press any key...'
   inkey(0)
   ?
   oReg := RegExp():new('^(.*copyright.*(\d{4})-(\d{4})*.*U.*)\x0a',PCRE_MULTILINE+PCRE_CASELESS) // count number of lines
   aRet := {}
   nStart := Seconds()
   nRet := oReg:exec(c,0)
   for i := 1 to nRet
      aadd( aRet, oReg:result(i) )
   next
   nEnd := Seconds()
   ? 'Results: '+LTrim(Str(Len(aRet)))+' in '+LTrim(Str(nEnd-nStart))+' seconds'
   for i := 1 to len(aRet)
      ? substr(c,aRet[i][1],aRet[i][2])
   next
   ? 'Press any key...'
   inkey(0)
   cls
   ? 'Test #4: Extract specific tag from HTML doc and display contents.'
   ? 'Expression: '+'<.*a\b.*name="sec3".*>(.*)<.*>'
   ? 'Looking for <a name="SEC3">'
   ? 'Press any key...'
   inkey(0)
   ?
   c := memoread('pcre.html')
   oReg := RegExp():new('<.*a\b.*name="SEC3".*>(.*)<.*>',PCRE_MULTILINE+PCRE_CASELESS)
   nStart := Seconds()
   nOffset := 0
   aRet := {}
   nStart := Seconds()
   nRet := oReg:exec(c,nOffset)
   for i := 1 to nRet
      aadd( aRet, oReg:result(i) )
   next
   nEnd := Seconds()
   ? 'Results: '+LTrim(Str(Len(aRet)))+' in '+LTrim(Str(nEnd-nStart))+' seconds'
   ? 'match all:'+substr(c,aRet[1][1],aRet[1][2])
   ? 'contents :'+substr(c,aRet[2][1],aRet[2][2])

   return (Nil)

