/*****************************
* Source : regexp.prg           
* System : General
* Author : Phil Ide           
* Created: 09/08/2002             
*                             
* Purpose: Interface to PCRE (Perl-Compatible Regular Expression) Library.
* ----------------------------
* History:                    
* ----------------------------
*    10/08/2002 13:00 PPI - Created
*****************************/

#ifndef _XBPRCE_
  #define _XBPCRE_

  // options
  #define PCRE_CASELESS        0x0001
  #define PCRE_MULTILINE       0x0002
  #define PCRE_DOTALL          0x0004
  #define PCRE_EXTENDED        0x0008
  #define PCRE_ANCHORED        0x0010
  #define PCRE_DOLLAR_ENDONLY  0x0020
  #define PCRE_EXTRA           0x0040
  #define PCRE_NOTBOL          0x0080
  #define PCRE_NOTEOL          0x0100
  #define PCRE_UNGREEDY        0x0200
  #define PCRE_NOTEMPTY        0x0400
  #define PCRE_UTF8            0x0800

  // Exec-time and get-time error codes

  #define PCRE_ERROR_NOMATCH        (-1)
  #define PCRE_ERROR_NULL           (-2)
  #define PCRE_ERROR_BADOPTION      (-3)
  #define PCRE_ERROR_BADMAGIC       (-4)
  #define PCRE_ERROR_UNKNOWN_NODE   (-5)
  #define PCRE_ERROR_NOMEMORY       (-6)
  #define PCRE_ERROR_NOSUBSTRING    (-7)
#endif

